// BTTestView.cpp : implementation of the CBTTestView class
//

#include "stdafx.h"
#include "BTTest.h"

#include "BTTestDoc.h"
#include "BTTestView.h"
#include "BTTestSub.h"
#include "NameInputDlg.h"

#include "BTLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//	Ήǉ}N
#define COMPORT TEXT("COM5:")

#define MODE_SEND		1
#define MODE_RECV		2
#define MODE_SENDRECV	3
#define MODE_RSSI		4

//	Ήǉϐ
BTST_DEVICEINFO stDeviceInfo;
HANDLE hPort, hFile;
UCHAR *SendData;
DWORD dwFileSize;
BOOL bDir;

/////////////////////////////////////////////////////////////////////////////
// CBTTestView

IMPLEMENT_DYNCREATE(CBTTestView, CFormView)

BEGIN_MESSAGE_MAP(CBTTestView, CFormView)
	//{{AFX_MSG_MAP(CBTTestView)
	ON_COMMAND(IDM_TEST_SEND, OnTestSend)
	ON_COMMAND(IDM_TEST_RECV, OnTestRecv)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(IDM_TEST_SERVER, OnTestServer)
	ON_COMMAND(IDM_INPUT_NAME, OnInputName)
	ON_COMMAND(IDM_TEST_SENDRECV, OnTestSendrecv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBTTestView construction/destruction

CBTTestView::CBTTestView()
	: CFormView(CBTTestView::IDD)
{
	//{{AFX_DATA_INIT(CBTTestView)
	m_edit1 = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

CBTTestView::~CBTTestView()
{
}

void CBTTestView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBTTestView)
	DDX_Text(pDX, IDC_EDIT1, m_edit1);
	//}}AFX_DATA_MAP
}

BOOL CBTTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBTTestView diagnostics

#ifdef _DEBUG
void CBTTestView::AssertValid() const
{
	CFormView::AssertValid();
}

void CBTTestView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CBTTestDoc* CBTTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBTTestDoc)));
	return (CBTTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBTTestView message handlers

void CBTTestView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	hPort = NULL;
	hFile = NULL;
	DataFile = TEXT("\\test.dat");
}

//	BluetoothfoCX肷
void CBTTestView::OnInputName() 
{
	// TODO: Add your command handler code here
	CNameInputDlg myNameDlg;
	myNameDlg.DoModal();

	BluetoothName = myNameDlg.m_comboName;
}

//	f[^t@C肷
void CBTTestView::OnFileOpen() 
{
	// TODO: Add your command handler code here
	CFileDialog myFileDlg(TRUE, NULL, DataFile, OFN_FILEMUSTEXIST | OFN_READONLY, 
							TEXT("DAT Files(*.dat)|*.dat|All Files(*.*)|*.*||"));
	myFileDlg.m_ofn.lpstrInitialDir = TEXT("\\");

	if (myFileDlg.DoModal() == IDOK) {
		DataFile = myFileDlg.m_ofn.lpstrFile;
	}
}

//	NCAgM[h
void CBTTestView::OnTestSend() 
{
	// TODO: Add your command handler code here
	HINSTANCE hInst;
	DWORD dwRecvNum;
	BOOL bRet;

	//	Clear Message
	m_edit1 = TEXT("");
	UpdateData(FALSE);
	DispMessage(TEXT("Send Test Start!\r\n"));

	//	Check Filename
	hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't open Datafile!"));
		CloseResource();
		return;
	}
	CloseHandle(hFile);

	//	Execute BT Connection
	bRet = BTConnect(MODE_SEND);
	if (bRet == FALSE) {
		DispMessage(TEXT("\r\nSend Test Failed!"));
		CloseResource();
		return;
	}

	//	Send Test
	DispMessage(TEXT("\r\nSend Data Start!"));

	hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't open Datafile!"));
		CloseResource();
		return;
	}

	dwFileSize = GetFileSize(hFile, NULL);
	SendData = new UCHAR [dwFileSize];

	bRet = ReadFile(hFile, SendData, dwFileSize, &dwRecvNum, NULL);
	CloseHandle(hFile);
	if (bRet == 0 || dwRecvNum != dwFileSize) {
		delete [] SendData;
		CloseResource();
		return;
	}

	//	i\p̃_CAO{bNX\
	hInst = AfxGetInstanceHandle();
	DialogBox(hInst, (LPCTSTR)IDD_SEND_DIALOG, this->m_hWnd, (DLGPROC)DispSendTest);

	DispMessage(TEXT("\r\nSend Test Completed!"));
	CloseResource();
}

//	NCAgM[h
void CBTTestView::OnTestRecv() 
{
	// TODO: Add your command handler code here
	HINSTANCE hInst;
	BOOL bRet;

	//	Clear Message
	m_edit1 = TEXT("");
	UpdateData(FALSE);
	DispMessage(TEXT("Receive Test Start!\r\n"));

	//	Execute BT Connection
	bRet = BTConnect(MODE_RECV);
	if (bRet == FALSE) {
		DispMessage(TEXT("\r\nReceive Test Failed!"));
		CloseResource();
		return;
	}

	//	Receive Test
	DispMessage(TEXT("\r\nReceive Data Start!"));

	//	i\p̃_CAO{bNX\
	hInst = AfxGetInstanceHandle();
	DialogBox(hInst, (LPCTSTR)IDD_RECV_DIALOG, this->m_hWnd, (DLGPROC)DispRecvTest);

	DispMessage(TEXT("\r\nReceive Test Completed!"));
	CloseResource();
}

//	NCAgM[h
void CBTTestView::OnTestSendrecv() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	HINSTANCE hInst;
	DWORD dwRecvNum;
	BOOL bRet;

	//	Clear Message
	m_edit1 = TEXT("");
	UpdateData(FALSE);
	DispMessage(TEXT("Send-Receive Test Start!\r\n"));

	//	Check Filename
	hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't open Datafile!"));
		CloseResource();
		return;
	}
	CloseHandle(hFile);

	//	Execute BT Connection
	bRet = BTConnect(MODE_SENDRECV);
	if (bRet == FALSE) {
		DispMessage(TEXT("\r\nSend-Receive Test Failed!"));
		CloseResource();
		return;
	}

	//	Send-Receive Test
	DispMessage(TEXT("\r\nSend Data Start!"));

	hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't open Datafile!"));
		CloseResource();
		return;
	}

	dwFileSize = GetFileSize(hFile, NULL);
	SendData = new UCHAR [dwFileSize];

	bRet = ReadFile(hFile, SendData, dwFileSize, &dwRecvNum, NULL);
	CloseHandle(hFile);
	if (bRet == 0 || dwRecvNum != dwFileSize) {
		delete [] SendData;
		CloseResource();
		return;
	}

	//	ŏ̒ʐM[h̐ݒ
	bDir = DIR_SEND;

	//	i\p̃_CAO{bNX\
	hInst = AfxGetInstanceHandle();
	DialogBox(hInst, (LPCTSTR)IDD_SENDRECV_DIALOG, this->m_hWnd, (DLGPROC)DispSendRecvTest);

	DispMessage(TEXT("\r\nSend-Receive Test Completed!"));
	CloseResource();
}

//	T[o[hiX[uœj
void CBTTestView::OnTestServer() 
{
	// TODO: Add your command handler code here
	HINSTANCE hInst;
	BTST_LOCALINFO stLocalInfo;
	DWORD dwRecvNum, dwModemStat, dwOldStat;
	UCHAR tempdata;
	TCHAR szProtoName[BTDEF_NAME_LENGTH];
	LONG lRet;
	BOOL bRet;

	//	Clear Message
	m_edit1 = TEXT("");
	UpdateData(FALSE);
	DispMessage(TEXT("Server Mode Start!\r\n"));

	//	Initialize
	lRet = BTLib_Initialize();
	if (lRet == BTERR_SUCCESS) {
		DispMessage(TEXT("Initialize Success."));
	} else {
		DispMessage(TEXT("Initialize Failure."));
		return;
	}

	lRet = BTLib_GetLocalInfo(&stLocalInfo);
	if (lRet == BTERR_SUCCESS) {
		DispMessage(TEXT("GetLocalInfo Success."));
	} else {
		DispMessage(TEXT("GetLocalInfo Failure."));
		return;
	}

	wcscpy(szProtoName, stLocalInfo.LocalName);
	wcscpy(stLocalInfo.LocalName, BluetoothName);
	lRet = BTLib_SetLocalInfo(&stLocalInfo);
	if (lRet == BTERR_SUCCESS) {
		DispMessage(TEXT("SetLocalInfo Success."));
	} else {
		DispMessage(TEXT("SetLocalInfo Failure."));
		return;
	}

	DispMessage(TEXT("\r\nConnection Start!"));

	hPort = CreateFile(COMPORT, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
	if (hPort == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't Open COM Port!"));
		CloseResource();
		return;
	}
	SetPortParam(hPort);

	//	M҂Ԃɂ
	DispMessage(TEXT("Waiting Connection..."));
	GetCommModemStatus(hPort, &dwOldStat);

	do {
		Sleep(1);
		GetCommModemStatus(hPort, &dwModemStat);
	} while (dwModemStat == dwOldStat);

	DispMessage(TEXT("Connection Success."));

	//	ڑpf[^ǂݎ̂Ă
	tempdata = 'A';
	while (tempdata == 'A') {
		Sleep(10);
		ReadFile(hPort, &tempdata, 1, &dwRecvNum, NULL);
	}

	switch (tempdata) {
		case 'S':
			DispMessage(TEXT("\r\nReceive Data Start!"));

			//	i\p̃_CAO{bNX\
			hInst = AfxGetInstanceHandle();
			DialogBox(hInst, (LPCTSTR)IDD_RECV_DIALOG, this->m_hWnd, (DLGPROC)DispRecvTest);

			DispMessage(TEXT("\r\nReceive Test Completed!"));
			break;

		case 'R':
			DispMessage(TEXT("\r\nSend Data Start!"));

			hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
			if (hFile == INVALID_HANDLE_VALUE) {
				DispMessage(TEXT("Can't open Datafile!"));
				CloseResource();
				return;
			}

			dwFileSize = GetFileSize(hFile, NULL);
			SendData = new UCHAR [dwFileSize];

			bRet = ReadFile(hFile, SendData, dwFileSize, &dwRecvNum, NULL);
			CloseHandle(hFile);
			if (bRet == 0 || dwRecvNum != dwFileSize) {
				delete [] SendData;
				CloseResource();
				return;
			}

			//	i\p̃_CAO{bNX\
			hInst = AfxGetInstanceHandle();
			DialogBox(hInst, (LPCTSTR)IDD_SEND_DIALOG, this->m_hWnd, (DLGPROC)DispSendTest);

			DispMessage(TEXT("\r\nSend Test Completed!"));
			break;

		case 'D':
			DispMessage(TEXT("\r\nSend-Receive Data Start!"));

			hFile = CreateFile(DataFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
			if (hFile == INVALID_HANDLE_VALUE) {
				DispMessage(TEXT("Can't open Datafile!"));
				CloseResource();
				return;
			}

			dwFileSize = GetFileSize(hFile, NULL);
			SendData = new UCHAR [dwFileSize];

			bRet = ReadFile(hFile, SendData, dwFileSize, &dwRecvNum, NULL);
			CloseHandle(hFile);
			if (bRet == 0 || dwRecvNum != dwFileSize) {
				delete [] SendData;
				CloseResource();
				return;
			}

			//	ŏ̒ʐM[h̐ݒ
			bDir = DIR_RECV;

			//	i\p̃_CAO{bNX\
			hInst = AfxGetInstanceHandle();
			DialogBox(hInst, (LPCTSTR)IDD_SENDRECV_DIALOG, this->m_hWnd, (DLGPROC)DispSendRecvTest);

			DispMessage(TEXT("\r\nSend-Receive Test Completed!"));
			break;

		default:
			DispMessage(TEXT("Command Receive Error!"));
	}

	wcscpy(stLocalInfo.LocalName, szProtoName);
	BTLib_SetLocalInfo(&stLocalInfo);

	CloseResource();
	DispMessage(TEXT("Server Mode Completed!"));
}

//	Ήǉ֐

BOOL CBTTestView::BTConnect(DWORD TestMode) 
{
	BTST_DEVICEINFO stDeviceInfo;
	HANDLE DeviceHandle[16];
	DWORD DeviceNumber, i;

	DWORD StartTime, StopTime;
	DWORD dwSendNum, dwModemStat, dwOldStat;
	UCHAR SendChar;
	TCHAR szMes[256];
	double restime;
	LONG lRet;
	BOOL bRet;

	//	Initialize
	lRet = BTLib_Initialize();
	if (lRet == BTERR_SUCCESS) {
		DispMessage(TEXT("Initialize Success."));
	} else {
		DispMessage(TEXT("Initialize Failure."));
		return FALSE;
	}

	//	Inquiry Test
	DispMessage(TEXT("\r\nInquiry Test Start!"));

	DeviceNumber = 16;
	StartTime = GetTickCount();
	lRet = BTLib_Inquiry(DeviceHandle, &DeviceNumber);
	StopTime = GetTickCount();

	if (lRet != BTERR_SUCCESS) {
		DispMessage(TEXT("Inquiry Test Failed."));
		CloseResource();
		return FALSE;
	}

	restime = CalcTimeResult(StartTime, StopTime);
	wsprintf(szMes, TEXT("Inquiry Time: %6.3f [s]"), restime);
	DispMessage(szMes);
	wsprintf(szMes, TEXT("%ld BT device found."), DeviceNumber);
	DispMessage(szMes);

	//	Connect Test
	DispMessage(TEXT("\r\nConnection Test Start!"));

	i = 0;
	wcscpy(stDeviceInfo.DeviceName, TEXT(""));
	for (i = 0; i < DeviceNumber; i ++) {
		lRet = BTLib_GetDeviceInfo(&stDeviceInfo, DeviceHandle[i]);

		if (wcslen(stDeviceInfo.DeviceName) > 0) {
			wsprintf(szMes, TEXT("Device%ld: %s"), i + 1, stDeviceInfo.DeviceName);
		} else {
			wsprintf(szMes, TEXT("Device%ld: Unknown Name"), i + 1);
		}
		DispMessage(szMes);

		if (wcscmp(stDeviceInfo.DeviceName, BluetoothName) == 0) {
			break;
		}
	}

	if (i == DeviceNumber) {
		DispMessage(TEXT("Can't find server Bluetooth Device."));
		CloseResource();
		return FALSE;
	}

	DispMessage(TEXT("Server Bluetooth device found."));

	lRet = BTLib_SelectDevice(&stDeviceInfo);
	if (lRet != BTERR_SUCCESS) {
		DispMessage(TEXT("SelectDevice Failed."));
		CloseResource();
		return FALSE;
	}

	hPort = CreateFile(COMPORT, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);					
	if (hPort == INVALID_HANDLE_VALUE) {
		DispMessage(TEXT("Can't Open COM Port!"));
		CloseResource();
		return FALSE;
	}
	SetPortParam(hPort);

	//	RlNVpLN^𑗐M
	GetCommModemStatus(hPort, &dwOldStat);
	StartTime = GetTickCount();
	do {
		WriteFile(hPort, "A", 1, &dwSendNum, NULL);
		Sleep(10);
		GetCommModemStatus(hPort, &dwModemStat);
	} while (dwModemStat == dwOldStat);
	StopTime = GetTickCount();

	restime = CalcTimeResult(StartTime, StopTime);
	wsprintf(szMes, TEXT("Connection Time: %6.3f [s]"), restime);
	DispMessage(szMes);

	//	RlNVĨLN^𑗐M
	switch (TestMode) {
		case MODE_SEND:
			SendChar = 'S';
			break;

		case MODE_RECV:
			SendChar = 'R';
			break;

		case MODE_SENDRECV:
			SendChar = 'D';
			break;

		default:
			DispMessage(TEXT("Test Mode Error!"));
			return FALSE;
	}

	bRet = WriteFile(hPort, &SendChar, 1, &dwSendNum, NULL);
	if (bRet == 0 || dwSendNum != 1) {
		DispMessage(TEXT("Send Command Failed."));
		return FALSE;
	}

	return TRUE;
}

void CBTTestView::DispMessage(CString szText) 
{
	UpdateData(TRUE);
	m_edit1 = m_edit1 + szText + TEXT("\r\n");
	UpdateData(FALSE);
}

void CBTTestView::CloseResource(void) 
{
	if (hFile != NULL) {
		CloseHandle(hFile);
		hFile = NULL;
	}

	Sleep(1000);
	if (hPort != NULL) {
		CloseHandle(hPort);
		hPort = NULL;
	}

	Sleep(2000);
	BTLib_DeInitialize();
}

//	End of source file
